/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ITEMPRECO                                                */
/* Tabela : ITEMPRECO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 27/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ITEMPRECO
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMPRECO FOR EACH ROW
BEGIN

   IF INSERTING THEN
      :NEW.DTULTATUITPR := SYSDATE;

      UPDATE PRODUTO
      SET DTULTATUPROD = SYSDATE
      WHERE CDPRODUTO  = :NEW.CDPRODUTO; 

      UPDATE ITMENUCONFTE
      SET DTULTATUITCT = SYSDATE
      WHERE CDIDENTBUTON  = :NEW.CDPRODUTO;

      UPDATE PRODOCORRE
      SET DTULTATUPOCO = SYSDATE
      WHERE CDPRODUTO  = :NEW.CDPRODUTO;

      UPDATE PRODLOJA
      SET DTULTATUPLOJ = SYSDATE
      WHERE CDPRODUTO  = :NEW.CDPRODUTO;

      UPDATE PRODUTOSEG
      SET DTULTATUPSEG = SYSDATE
      WHERE CDPRODUTO  = :NEW.CDPRODUTO; 

   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUITPR := SYSDATE;

     /*Sempre que a tabela itempreco era alterada, o dtultatu das tabelas abaixo tambem eram atualizados,
       fazendo aumentar a quantidade de registros a serem baixados para o MSDE sem necessidade.*/


      UPDATE PRODUTO
      SET DTULTATUPROD = SYSDATE
      WHERE CDPRODUTO  = :OLD.CDPRODUTO;

      UPDATE ITMENUCONFTE
      SET DTULTATUITCT = SYSDATE
      WHERE CDIDENTBUTON  = :OLD.CDPRODUTO;
/*
      UPDATE PRODOCORRE
      SET DTULTATUPOCO = SYSDATE
      WHERE CDPRODUTO  = :OLD.CDPRODUTO;

      UPDATE PRODLOJA
      SET DTULTATUPLOJ = SYSDATE
      WHERE CDPRODUTO  = :OLD.CDPRODUTO;

      UPDATE PRODUTOSEG
      SET DTULTATUPSEG = SYSDATE
      WHERE CDPRODUTO  = :OLD.CDPRODUTO;
*/

   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ITEMPRECO',:OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDTABEPREC='||:OLD.CDTABEPREC||';DTINIVGPREC='||TO_CHAR(:OLD.DTINIVGPREC,'DD/MM/YYYY')||';CDPRODUTO='||:OLD.CDPRODUTO||';CDPRPAITABPR='||:OLD.CDPRPAITABPR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ITEMPRECO MODIFY DTULTATUITPR DEFAULT SYSDATE
/

UPDATE ITEMPRECO SET DTULTATUITPR = SYSDATE WHERE DTULTATUITPR IS NULL
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ITEMPRECO','5.07.005'); END;
/

