export class UploadFileFornwardSoli {
	public static indexFile = '_____file_____';

	public static dirTest = {
		'C:\\web_635': {
			files: [
				'ALUS-20414 (F2EEC598).00.p2s',
				'aLUS-20414 (F2EEC598).00.p2s.backup',
				'SLUS-20414 (F2EEC598).01.p2s',
				'SLUS-20414 (F2EEC598).01.p2s.backup',
			],
		},
		'C:\\web_635\\bios': {
			files: [
				'PS2 Bios 30004R V6 Pal.bin',
				'PS2 Bios 30004R V6 Pal.MEC',
				'PS2 Bios 30004R V6 Pal.NVM',
				'PS2 Bios JAP SCPH10000.bin',
				'PS2 Bios JAP SCPH10000.MEC',
				'PS2 Bios JAP SCPH10000.NVM',
				'PS2 Bios PAL SCPH30004R V6.bin',
				'PS2 Bios PAL SCPH30004R V6.NVM',
				'rom1.bin',
				'SCPH-70004_BIOS_V12_PAL_200.BIN',
				'SCPH-70004_BIOS_V12_PAL_200.EROM',
				'SCPH-70004_BIOS_V12_PAL_200.NVM',
				'SCPH-70004_BIOS_V12_PAL_200.ROM1',
				'SCPH-70004_BIOS_V12_PAL_200.ROM2',
				'SCPH-70012_BIOS_V12_USA_200.bin',
				'SCPH-70012_BIOS_V12_USA_200.MEC',
				'SCPH-70012_BIOS_V12_USA_200.NVM',
				'scph10000.bin',
				'scph10000.MEC',
				'scph10000.NVM',
				'scph3004R.bin',
				'scph3004R.MEC',
				'scph3004R.NVM',
				'scph39001.bin',
				'scph39001.MEC',
				'scph39001.NVM',
			],
		},
		'C:\\web_635\\inis_1.4.0': {
			files: [
				'Dev9null.ini',
				'FWnull.ini',
				'GSdx.ini',
				'LilyPad.ini',
				'PCS209F.tmp',
				'PCSX2_ui.ini',
				'PCSX2_vm.ini',
				'SPU2-X.ini',
				'USBnull.ini',
			],
		},
		'C:\\web_635\\sstates': {
			files: [
				'SLUS-20414 (F2EEC598).00.p2s',
				'SLUS-20414 (F2EEC598).00.p2s.backup',
				'SLUS-20414 (F2EEC598).01.p2s',
				'SLUS-20414 (F2EEC598).01.p2s.backup',
			],
		},
		'C:\\web_635\\logs': {
			files: [
				'emuLog.txt',
			],
		},
		'C:\\web_635\\logs\\memcards': {
			files: [
				'Mcd001.ps2',
				'Mcd002.ps2',
			],
		},
	};

	public static setNodeTree(dirInit: string, directories: any) {
		let nodes = this.getNodes(directories, '\\');
		if (nodes[0] && nodes[0].id === dirInit) {
			nodes = nodes[0].children;
		}
		nodes.sort((obja: any, objb: any) => {
			const a = obja.isLeaf;
			const b = objb.isLeaf;
			let aux: number = 0;
			if (a === b) {
				aux = 0;
			} else if (a) {
				aux = 1;
			} else if (b) {
				aux = -1;
			}
			return aux;
		});
		return nodes;
	}

	public static montDir(fileNameInt: string, node: any, indexs: number[]) {
		let nodeIndex = node;
		let fileName = fileNameInt;
		indexs?.forEach((value, index) => {
			fileName = `${fileName}\\${nodeIndex[index].title}`;
			nodeIndex = nodeIndex.children;
		});
		return fileName;
	}

	public static pushInExistsNode(nodes: any, node: any, dir: any): any {
		return nodes.some((nodeAux: any) => {
			if (!nodeAux.isLeaf && nodeAux.id === dir) {
				nodeAux.children.push(node);
				return true;
			}
			if (nodeAux.children.length > 0) {
				return this.pushInExistsNode(nodeAux.children, node, dir);
			}
			return false;
		});
	}

	public static getNodes(directories: any, separator: string) {
		const nodes = <any>[];

		Object.keys(directories).forEach((dir) => {
			const splitedDir = dir.split(separator);
			const nodeTitle = splitedDir.pop();

			const node = <any>{
				title: nodeTitle,
				isLeaf: false,
				isExpanded: false,
				id: dir,
				children: [],
			};

			directories[dir].files.forEach((file: any) => {
				node.children.push({
					title: file,
					isLeaf: true,
					id: dir + separator + file,
					children: [],
				});
			});

			const nodeToPush = this.pushInExistsNode(nodes, node, splitedDir.join(separator));
			if (!nodeToPush) {
				nodes.push(node);
			}
		});

		return nodes;
	}
}
